/*
 * snapshot.h
 */

#ifdef ALLOCATE
#define EXTERN
#define INIT(x) = {x}
#else
#define EXTERN extern
#define INIT(x)
#endif

#define NTERMS 6		/* Max. # of $TERM values per termdef. */

/*
 * All the info we need to know about a terminal in order to make a
 * snapshot of its screen.
 */
struct termdef {
    char   *td_terms[NTERMS];	/* Possible $TERM values or NULLs. */
    int     (*td_savepos) ();	/* Function to save cursor position. */
    int     (*td_restorepos) ();/* Function to restore cursor position. */
    int     (*td_transline) ();	/* Function to request 1 line transmit. */
    int     td_minline;		/* Minimum legal line number. */
    int     td_maxline;		/* Maximum legal line number. */
};

EXTERN struct termdef *tp;

#define savepos (*tp->td_savepos)
#define restorepos (*tp->td_restorepos)
#define transline (*tp->td_transline)
#define minline tp->td_minline
#define maxline tp->td_maxline

#include <setjmp.h>

EXTERN jmp_buf sjbuf;
